package com.ruoyi.system.controller;

import com.ruoyi.common.security.annotation.InnerAuth;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.DeleteMapping;
import com.ruoyi.common.core.web.domain.AjaxResult;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.core.utils.poi.ExcelUtil;
import javax.servlet.http.HttpServletResponse;
import org.springframework.web.bind.annotation.GetMapping;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import java.util.List;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.system.api.domain.SysOperLog;
import org.springframework.beans.factory.annotation.Autowired;
import com.ruoyi.system.service.ISysOperLogService;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.ruoyi.common.core.web.controller.BaseController;

@RestController
@RequestMapping({ "/operlog" })
public class SysOperlogController extends BaseController
{
    @Autowired
    private ISysOperLogService operLogService;
    
    @RequiresPermissions({ "system:operlog:list" })
    @GetMapping({ "/list" })
    public TableDataInfo list(final SysOperLog operLog) {
        this.startPage();
        final List<SysOperLog> list = this.operLogService.selectOperLogList(operLog);
        return this.getDataTable((List)list);
    }
    
    @Log(title = "操作日志", businessType = BusinessType.EXPORT)
    @RequiresPermissions({ "system:operlog:export" })
    @PostMapping({ "/export" })
    public void export(final HttpServletResponse response, final SysOperLog operLog) {
        final List<SysOperLog> list = this.operLogService.selectOperLogList(operLog);
        final ExcelUtil<SysOperLog> util = (ExcelUtil<SysOperLog>)new ExcelUtil((Class)SysOperLog.class);
        util.exportExcel(response, (List)list, "操作日志");
    }
    
    @Log(title = "操作日志", businessType = BusinessType.DELETE)
    @RequiresPermissions({ "system:operlog:remove" })
    @DeleteMapping({ "/{operIds}" })
    public AjaxResult remove(@PathVariable final Long[] operIds) {
        return this.toAjax(this.operLogService.deleteOperLogByIds(operIds));
    }
    
    @RequiresPermissions({ "system:operlog:remove" })
    @Log(title = "操作日志", businessType = BusinessType.CLEAN)
    @DeleteMapping({ "/clean" })
    public AjaxResult clean() {
        this.operLogService.cleanOperLog();
        return this.success();
    }
    
    @InnerAuth
    @PostMapping
    public AjaxResult add(@RequestBody final SysOperLog operLog) {
        return this.toAjax(this.operLogService.insertOperlog(operLog));
    }
}
